package com.fjhx.stock.service;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.base.BaseService;
import com.fjhx.base.Condition;
import com.fjhx.entity.stock.StockWater;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 出入库 服务类
 * </p>
 *
 * @author ${author}
 * @since 2022-07-04
 */
public interface StockWaterService extends BaseService<StockWater> {

    Map<String, Object> getPickingStatistics(Map<String, String> condition);

    Map<String, Integer> getPickingStockChangeTypeCount(Map<String, String> condition);

    Page<Map<String, Object>> getPickingPage(Map<String, String> condition);

    Map<String, Object> contractPaymentStatistics(Map<String, String> condition);

    Page<Map<String, Object>> subscriptionAmountPage(Map<String, String> condition);

    Map<String, Object> remainingToday(Map<String, String> condition);

    Page<Map<String, Object>> remainingTodayPage(Map<String, String> condition);

    List<Map<String, Object>> remainingTodayList(Map<String, String> condition);

    List<Map<String, Object>> inStockList(Map<String, String> condition);

    Page<Map<String, Object>> receiptSequence(Map<String, String> condition);

    List<Map<String, Object>> contractPaymentList(Map<String, String> condition);

    List<Map<String, Object>> receiptList(Map<String, String> condition);

    List<JSONObject> issue(Condition condition);

    List<JSONObject> materialReturn(Condition condition);

    List<JSONObject> transferIn(Condition condition);

    List<JSONObject> transferOut(Condition condition);

    List<Map<String, Object>> inventoryDetails(Condition condition);

    Page<Map<String, Object>> outPage(Condition condition);

    Map<String, Object> outStatistics(Condition condition);

    void swap(Condition condition);

}
